



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>高级Bash脚本编程（二）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">高级Bash脚本编程（二）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 17:37:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>高级Bash脚本编程（二）</h1>
<h2>退出</h2>
<h3>退出状态码</h3>
<ol><li>退出：exit 被用来结束一个脚本，它也返回一个值，并且这个值会传递给脚本的父进程，父进程会使用这个值做下一步的处理。</li>
<li>每个命令都会返回一个退出状态码，成功的命令返回 0，不成功的命令返回非零值，非零值通常都被解释成一个错误码。</li>
<li>练习截图</li></ol>
<h3>反转条件用法</h3>
<p>! 逻辑“非”操作符，将会反转命令或条件测试的结果，并且这会影响退出状态码。</p>
<h2>条件判断</h2>
<h3>if/then 结构用来判断命令列表的退出状态码是否为 0，因为0表示成功，如果成功的话，这里应该那么就执行接下来的一个或多个命令。true返回的是0,false返回的是1</h3>
<ul><li>test3.sh</li></ul>
<h3>多级比较</h3>
<pre class="prettyprint linenums"><code> #!/bin/bash

 if echo &quot;Next *if* is part of the comparison for the first *if*.&quot;<br />
   if [[ $comparison = &quot;integer&quot; ]]<br />
     then (( a &lt; b )) # (( 算数表达式 ))， 用作算数运算<br />
   else<br />
     [[ $a &lt; $b ]]<br />
   fi<br />
 then<br />
  echo '$a is less than $b'<br />
 fi<br />
</code></pre>
<ul><li>注意： ((...))和let...如果运算结果为非0，该语句退出码为0，否则为1；[[...]]是作为一个单独的语句并且会返回一个退出码<br /><br />
，真返回0，假返回1.</li></ul>
<h3>真假判断</h3>
<p>NULL和未初始化的变量、初始化为Null的变量，$false为假</p>
<h3>(( )) 结构</h3>
<ul><li>扩展并计算一个算术表达式的值。如果表达式的结果为0，那么返回的退出状态码为1，或者是&quot;假&quot;。而一个非零值的表达式所返回的退出状态码将为0，或者是&quot;true&quot;。</li>
<li>(( ... ))结构可以用来计算并测试算术表达式的结果，退出状态将会与[ ... ]结构完全相反。</li></ul>
<h2>文件测试操作符</h2>
<p>操作符</p>
<p>说明</p>
<ul><li>-e 文件存在</li>
<li>-a 文件存在，这个选项的效果与 -e 相同。但是它已经被“弃用”了，并且不鼓励使用。</li>
<li>-f 表示这个文件是一个一般文件（并不是目录或者设备文件）</li>
<li>-s 文件大小不为零</li>
<li>-d 表示这是一个目录</li>
<li>-b 表示这是一个块设备（软盘，光驱，等等）</li>
<li>-c 表示这是一个字符设备（键盘，modem，声卡，等等）</li>
<li>-p 这个文件是一个管道</li>
<li>-h 这是一个符号链接</li>
<li>-L 这是一个符号链接</li>
<li>-S 表示这是一个socket</li>
<li>-t 文件（描述符）被关联到一个终端上，这个测试选项一般被用来检测脚本中的stdin([ -t 0 ]) 或者 stdout([ -t 1 ])是否来自于一个终端</li>
<li>-r 文件是否具有可读权限（指的是正在运行这个测试命令的用户是否具有读权限）</li>
<li>-w 文件是否具有可写权限（指的是正在运行这个测试命令的用户是否具有写权限）</li>
<li>-x 文件是否具有可执行权限（指的是正在运行这个测试命令的用户是否具有可执行权限）</li>
<li>-g set-group-id(sgid)标记被设置到文件或目录上</li>
<li>-k 设置粘贴位</li>
<li>-O 判断你是否是文件的拥有者</li>
<li>-G 文件的group-id是否与你的相同</li>
<li>-N 从文件上一次被读取到现在为止, 文件是否被修改过</li>
<li>f1 -nt f2 文件f1比文件f2新</li>
<li>f1 -ot f2 文件f1比文件f2旧</li>
<li>f1 -ef f2 文件f1和文件f2是相同文件的硬链接</li>
<li>! “非”，反转上边所有测试的结果（如果没给出条件，那么返回真）</li></ul>
<h2>二元比较操作符</h2>
<h3>整数比较</h3>
<ul><li><p>-eq 等于<br /><br />
if [ &quot;\(a&quot; -eq &quot;\)b&quot; ]</p></li>
<li><p>-ne 不等于<br /><br />
if [ &quot;\(a&quot; -ne &quot;\)b&quot; ]</p></li>
<li><p>-gt 大于<br /><br />
if [ &quot;\(a&quot; -gt &quot;\)b&quot; ]</p></li>
<li><p>-ge 大于等于<br /><br />
if [ &quot;\(a&quot; -ge &quot;\)b&quot; ]</p></li>
<li><p>-lt 小于<br /><br />
if [ &quot;\(a&quot; -lt &quot;\)b&quot; ]</p></li>
<li><p>-le 小于等于<br /><br />
if [ &quot;\(a&quot; -le &quot;\)b&quot; ]</p></li>
<li><p>&lt; 小于(在双括号中使用)<br /><br />
((&quot;\(a&quot; &lt; &quot;\)b&quot;))</p></li>
<li><p>&lt;= 小于等于(在双括号中使用)<br /><br />
((&quot;\(a&quot; &lt;= &quot;\)b&quot;))</p></li>
<li><p>大于(在双括号中使用)<br /><br />
((&quot;\(a&quot; &gt; &quot;\)b&quot;))</p></li>
<li><p>= 大于等于(在双括号中使用)<br /><br />
((&quot;\(a&quot; &gt;= &quot;\)b&quot;))</p></li></ul>
<h3>字符串比较</h3>
<ul><li><p>= 等于<br /><br />
if [ &quot;\(a&quot; = &quot;\)b&quot; ]</p></li>
<li><p>== 等于，与=等价<br /><br />
if [ &quot;\(a&quot; == &quot;\)b&quot; ]</p></li>
<li><p>!= 不等号<br /><br />
if [ &quot;\(a&quot; != &quot;\)b&quot; ]</p></li>
<li><p>&lt; 小于，按照ASCII字符进行排序<br /><br />
if [[ &quot;\(a&quot; &lt; &quot;\)b&quot; ]]<br /><br />
if [ &quot;\(a&quot; \&lt; &quot;\)b&quot; ]<br /><br />
注意&quot;&lt;&quot;使用在[ ]结构中的时候需要被转义</p></li>
<li><p>大于，按照ASCII字符进行排序<br /><br />
if [[ &quot;\(a&quot; &gt; &quot;\)b&quot; ]]<br /><br />
if [ &quot;\(a&quot; \&gt; &quot;\)b&quot; ]<br /><br />
注意“&gt;”使用在[ ]结构中的时候需要被转义</p></li>
<li><p>-z 字符串为“null”，意思就是字符串长度为零 -n 字符串不为“null”</p></li></ul>
<h3>实验过程截图</h3>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/886825/201610/886825-20161016183817342-1655071550.png"></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/886825/201610/886825-20161016183830733-421080414.png"></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/886825/201610/886825-20161016183847045-1708928187.png"></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/886825/201610/886825-20161016183853092-2111472839.png"></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2n1wq7.html">移动端HTML5音频与视频问题及解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pkmr78.html">BundleConfig&period;cs</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mwx42q.html">linux 系统性能分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zxy31q.html">SharedPreference写入-读取</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql361eq.html">Node&period;js网络编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kw4y58.html">Phoenix实现用SQL查询HBase</a>
		</li>
						<li><a href="https://www.batexi.com/a/96op07v9.html">关于SharePoint REST中的授权的研究</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1j3p59.html">Flex应用一览表</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1gjnk9.html">Post&sol;Redirect&sol;Get pattern &vert; PRG 模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn7nej8.html">应用Observer接口实践Observer模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gee6648.html">POJ 1631 Bridging signals（LIS  二分法  高速方法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me2kp6q.html">Redis3</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yw4yr8.html">实现pow&lpar;int x&comma; int y&rpar;，即x的y次方  ； 异或交换两个数；</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zovwdxq.html">jQuery插件---轻量级的弹出窗口wBox</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljvmz19.html">cssradius</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1ky5dq.html">Java：配置环境（Mac）&mdash;&mdash;Tomcat</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyywppdq.html">Qt笔记之Q&lowbar;DECLARE&lowbar;METATYPE&lpar;Type&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ovpjg8.html">&commat;Transactional&lpar;rollbackFor &equals; Exception&period;class&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/902r45nq.html">c语言之函数参数传递之数组篇&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk3nr18.html">javascript数据结构与算法--基本排序算法（冒泡、选择、排序）及效率比较</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93prz5z8.html">SpringMvc 400 Bad Request解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvnkejq.html">Solr服务搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvnm1mq.html">HTTP&sol;2笔记之帧</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ev67x9.html">MQTT的学习研究（二）moquette-mqtt 的使用之mqtt broker的启动</a>
			</li>
						<li><a href="https://www.batexi.com/a/953l4ke8.html">apply的调用  http&colon;&sol;&sol;bbs&period;51js&period;com&sol;thread-82017-1-3&period;html</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2keorvq.html">【Android M】获取屏幕锁定的相关信息：&OpenCurlyDoubleQuote;无&rdquo;，&OpenCurlyDoubleQuote;滑动&rdquo;，&OpenCurlyDoubleQuote;PIN码&rdquo;，&amp;quot&semi;图案&amp;quot&semi;，&amp;quot&semi;密码&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj6gr08.html">Python class的属性访问控制和内建函数重写实现高级功能以及&commat;property</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvepxo19.html">Express 框架的安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/963njkn9.html">Think PHP递归重新排序无限极子分类数组（递归无限极分类）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj4mg28.html">310实验室（六）CMake学习心得</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
